#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "aldr9.h"
#include "aldr9err.h"
#include "main.h"

#pragma pack(4)
typedef struct _tagDebugData
{
	DWORD dwIrqCount;
	DWORD dwDebug;
	DWORD dwIDMA;
	DWORD dwPack;	
	DWORD dwLoadTrace;
	WORD  lpwPack[40];
} DebugData;
#pragma pack()

bool blGetDebugData( HANDLE hDrv)
{
	DWORD dwReaded, dwI;
	DebugData dd;

	if( DeviceIoControl( hDrv, drvA9GetDebugData,
						 NULL, 0,
						 &dd, sizeof( DebugData),
						 &dwReaded, NULL)== 0)
		return blShowErr( hDrv, "blGetDebugData", 0, GetLastError());
	printf( " dwIrqCount: %d\n", dd.dwIrqCount);
	printf( " dwDebug:    %d\n", dd.dwDebug);
	printf( " dwIDMA:     %d\n", dd.dwIDMA);
	printf( " dwPack:     %08X\n", dd.dwPack);
	printf( " dwLoadTrace:%d\n", dd.dwLoadTrace);
	printf( " lpdwPack: ");
	for( dwI= 0; dwI< 20; dwI++)
		printf( "%04X ", dd.lpwPack[dwI]);
	printf( "\n");
	return true;
}
