//***************************************************************************
// Agat RT, Russia, Moscow, tel.262-09-67, 728-36-69, 747-51-12
// 			    tel.287-81-99, 287-81-81, 204-08-76
// Alder Driver Error Header File
// 20/11/2002 Version 3.37.114.1
// Board load file 107 and higher
//***************************************************************************

#if !defined(A9_DEBUG_HEADER)
#define A9_DEBUG_HEADER

#include "Aldr9.h"

// Debug routins
#define drvA9FirstDebugCmd			0x00000700

#define drvA9GetIDMATable			DrvIdent+ 0x00000700
#define drvA9GetLinesTable			DrvIdent+ 0x00000710
#define drvA9GetDebugData			DrvIdent+ 0x00000720
#define drvA9GetConfData			DrvIdent+ 0x00000730
#define drvA9SetE1MonitorMode		DrvIdent+ 0x00000740
#define drvA9GetE1MonitorData		DrvIdent+ 0x00000750
#define drvA9GetLogCommands			DrvIdent+ 0x00000760
#define drvA9GetE1MonitorTS			DrvIdent+ 0x00000770

#define drvA9LastDebugCmd			0x00000770

#pragma pack(4)

typedef struct tagAdspLinesTable
{	
	DWORD		dwIDMAID;
	DWORD		dwFirstLine;
	DWORD		dwLinesAmount;
	DWORD 		dwVoiceLinesAmount;
} AdspLinesTable;

typedef struct _tagDebugData
{
	DWORD dwIrqCount;
	DWORD dwDebug;
	DWORD dwIDMA;
	DWORD dwPack;
	DWORD dwLoadTrace;
	WORD  lpwPack[40];
} DebugData;

#define E1MonitorDisable	0x00
#define E1Q921Monitor		0x01
#define E1Q931Monitor		0x02
#define E1Q921Q931Monitor	0x03
#define E1CASMonitor		0x02
#define E1MFRMonitor		0x08
#define E1CASMFRMonitor		0x0C

typedef struct _tagE1MonitorParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwMode;
} E1MonitorParams;

typedef struct _tagE1MonitorDataParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
} E1MonitorDataParams;

typedef struct _tagLogCmdDataParams
{
	DWORD dwBoardHandle;
	DWORD dwIDMA;
} LogCmdDataParams;

typedef struct _tagIdentLineParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
} IdentLineParams;

typedef struct _tagE1MonitorTSInfo
{
	DWORD dwConnectionNumber;
	DWORD dwTimeSlotNumber;
} E1MonitorTSInfo;

#pragma pack()

#endif
