//**********************************************************************
// Agat RT, Russia, Moscow, tel.262-09-67, 747-51-12, 728-36-69
// 			    tel.287-81-99, 287-81-81, 204-08-76
// Alder9 Driver Main Header File
// 10/11/2002 Version 3.37.114.1
//   Alder-9, Alder-9P, Alder-10LP, Alder-10LPS, Alder-9LPO
// Board loader v107 and higher
//**********************************************************************

#if !defined( ALDER9_HEADER)
#define ALDER9_HEADER					1

#if defined( __cplusplus)
extern "C"
#endif

#define DrvIdent						0xFBF00000

// Tree VxD Driver fuctions
#define drvA9GetVersion					DrvIdent+ 0x00000010
#define drvA9GetBoardType				DrvIdent+ 0x00000020
#define drvA9GetLastError				DrvIdent+ 0x00000030

#define drvA9OpenBoard					DrvIdent+ 0x00000040
#define drvA9CloseBoard					DrvIdent+ 0x00000050
#define drvA9StartBoards  				DrvIdent+ 0x00000060
#define drvA9StopBoards	  				DrvIdent+ 0x00000070
#define drvA9SetIrqFrequency			DrvIdent+ 0x00000080
#define drvA9GetLinesStatus 			DrvIdent+ 0x00000090
#define drvA9SetPhoneParams				DrvIdent+ 0x000000A0
#define drvA9PutVoiceData				DrvIdent+ 0x000000B0
#define drvA9SetVolume	   				DrvIdent+ 0x000000C0
#define drvA9Ring						DrvIdent+ 0x000000D0
#define drvA9Lock						DrvIdent+ 0x000000E0
#define drvA9SetPlayAGC					DrvIdent+ 0x000000F0
#define drvA9SetRecord	   				DrvIdent+ 0x00000100
#define drvA9GetVoiceData				DrvIdent+ 0x00000110
#define drvA9SetGain 	  				DrvIdent+ 0x00000120
#define drvA9SetRecordAGC				DrvIdent+ 0x00000130
#define drvA9SetVox						DrvIdent+ 0x00000140
#define drvA9GenerateTone				DrvIdent+ 0x00000150
#define drvA9GeneratePBXTone			DrvIdent+ 0x00000160
#define drvA9SetVadLevel				DrvIdent+ 0x00000170
#define drvA9SetAon						DrvIdent+ 0x00000180
#define drvA9SetEchocanceler			DrvIdent+ 0x00000190
#define drvA9SetLevelIndication			DrvIdent+ 0x000001A0
#define drvA9SetAccuParams				DrvIdent+ 0x000001B0
#define drvA9SetConnectionMode			DrvIdent+ 0x000001C0
#define drvA9SetHook					DrvIdent+ 0x000001D0
#define drvA9Dial						DrvIdent+ 0x000001E0
#define drvA9SetPlayModeEx				DrvIdent+ 0x000001F0
#define drvA9SetSimplexSwitch			DrvIdent+ 0x00000200
#define drvA9SetNoiseVolume				DrvIdent+ 0x00000210
#define drvA9PutNoiseBlocks				DrvIdent+ 0x00000220

#define drvA9GetPciBoardAmount			DrvIdent+ 0x00000230
#define drvA9GetPciBoardInfo			DrvIdent+ 0x00000240

// E1 routins
#define drvA9SetE1RawMode				DrvIdent+ 0x00000250 //For E1 lines only
#define drvA9GetE1Status				DrvIdent+ 0x00000260 //For E1 lines only
#define drvA9GetE1RawData				DrvIdent+ 0x00000270 //For E1 lines only
#define drvA9PutE1RawData				DrvIdent+ 0x00000280 //For E1 lines only

// E1 params routins
#define drvA9SetE1SynchroType			DrvIdent+ 0x00000290 //For E1 lines only
#define drvA9SetE1LinearCode			DrvIdent+ 0x000002A0 //For E1 lines only
#define drvA9GetE1HardwareProperties 	DrvIdent+ 0x000002B0 //For E1 lines only
#define drvA9SetE1ConnectionType		DrvIdent+ 0x000002C0 //For E1 lines only
#define drvA9SetE1DTEMode				DrvIdent+ 0x000002D0 //For E1 lines only
#define drvA9SetE1VoiceSynchro			DrvIdent+ 0x000002E0 //For E1 lines only

#define drvA9SetLineType				DrvIdent+ 0x000002F0 //For E1 lines only
#define drvA9SetE1ToneDetector			DrvIdent+ 0x00000300 //For E1 lines only
#define drvA9E1ToneGenerator			DrvIdent+ 0x00000310 //For E1 lines only

#define drvA9SetConference				DrvIdent+ 0x00000320
#define drvA9SetSimplexSwitchEx			DrvIdent+ 0x00000330
#define drvA9SetDTMFFiltering			DrvIdent+ 0x00000340
#define drvA9SetNoiseCanceler			DrvIdent+ 0x00000350
#define drvA9SetPolarityReversal		DrvIdent+ 0x00000360
#define drvA9OpenIsdnBoard				DrvIdent+ 0x00000370
#define drvA9SetE1DialMode				DrvIdent+ 0x00000380
#define drvA9SetE1CalledNumberParams 	DrvIdent+ 0x00000390
#define drvA9SetE1CallerNumberParams 	DrvIdent+ 0x000003A0
#define drvA9SetE1MFRParams 			DrvIdent+ 0x000003B0
#define drvA9SetE1OverlapTimeOutParams 	DrvIdent+ 0x000003C0
#define drvA9GetBoardProperties			DrvIdent+ 0x000003D0
#define drvA9IsPnPDriver				DrvIdent+ 0x000003E0
#define drvA9Flash						DrvIdent+ 0x000003F0
#define drvA9SetLineBreakParams			DrvIdent+ 0x00000400
#define drvA9SetDTMFDialLevel			DrvIdent+ 0x00000410
#define drvA9SetPBXToneLevel			DrvIdent+ 0x00000420
#define drvA9SetToneLevel				DrvIdent+ 0x00000430
#define drvA9SetDTMFDetectorSensibility DrvIdent+ 0x00000440
#define drvA9SetGainMode 				DrvIdent+ 0x00000450
#define drvA9SetDTMFDetectorMode		DrvIdent+ 0x00000460

// Alder Board RecordMode
#define	drvNoRecord					0
#define	drvGsmRecord				1	// GSM with Motorola bit sequence
#define	drvMuLawRecord				2	// G711 (CCITT MuLaw)
#define	drvALawRecord				3	// G711 (CCITT A-Law)
#define	drvPcmRecord				4	// Pulse coding modilation
#define	drvMsGsmRecord				5	// Microsoft GSM (PC bit sequence)
#define	drvG729Record				6	// G729
#define	drvMpmlqRecord				7	// G723.1 MPMLQ
#define drvAcelpRecord				8	// G723.1 ACELP

// Alder Line Play Mode
#define exPlayOrdinary				0
#define exPlayUniform				1

#define IsaBoard					0x01
#define PciBoard					0X02

// Alder Board Type
#define Alder9Board					0x81
#define Alder10Board				0x82
#define Alder10LPBoard				0x85
#define Alder9IsdnBoard				0xC7
#define Alder10LPSBoard				0x86
#define Alder10LPOBoard				0x87

// E1 Attic type
#define AtticE1Terminal60			0x84
#define AtticE1Terminal30			0x86
#define AtticE1Monitor30			0x87

// E1 STS
#define AlderE1R15STS				0x10
#define AlderE1R2STS				0x20
#define AlderE1EDSS1STS				0x30
#define AlderE1QSIGSTS				0x40
#define AlderE1V5STS				0x50
#define AlderE1OKS7STS				0x70

// Alder Line LineType
#define AlderFullPhoneLine			0
#define AlderAccuLine				1
#define AlderSafePhoneLine			2
#define AlderAbonentPhoneLine		3
#define AlderE1Line					4
#define AlderE1MonitoringLine		5
#define AlderIsdnMonitoringLine		6

// Alder Driver Line Status
#define drvAlderLineHook           	0x00000001
#define drvAlderLineAccu           	0x00000002
#define drvAlderLineLevel          	0x00000004
#define drvAlderLineRing			0x00000008
#define drvAlderLineOutgoing		0x00000010
#define drvAlderLineIncoming		0x00000020
#define drvAlderLineNoDialTone		0x00000040
#define drvAlderLineDialTone		0x00000080
#define drvAlderLineBackRing		0x00000100
#define drvAlderLineBusy			0x00000200
#define drvAlderLineDefined			0x00000400	
#define drvAlderLineCallerID		0x00000400	// For E1 lines only
#define drvAlderLinePulseNum		0x00000800
#define drvAlderLineCalledID		0x00000800	// For E1 lines only
#define drvAlderLineToneNum			0x00001000
#define drvAlderLineNumDialed		0x00002000
#define drvAlderLineRecord			0x00004000
#define drvAlderLinePlayed			0x00008000
#define drvAlderLineInNumFault		0x00010000
#define drvAlderLineInVox			0x00020000
#define drvAlderLineVAD				0x00080000
#define drvAlderLineToneNumDialed	0x00100000
#define drvAlderLineFAX				0x00200000
#define drvAlderLineConnect			0x00400000
#define drvAlderLineFlash			0x00800000
#define drvAlderLineLocked			0x01000000
#define drvAlderLineNoSynchro		0x02000000	// For E1 lines only
#define drvAlderLineEndPlay			0x04000000	// 
#define drvAlderLinePolarity		0x08000000	// Polarity reversal
#define drvAlderLineRelease			0x10000000	// For E1 line only
#define drvAlderLineBreak			0x20000000	// For terminal analog line only
#define drvAlderLineTSReady			0x40000000	// For E1 line only

#define drvAlderBoardError			0x80000000

#define IsaBoard					0x01
#define PciBoard					0X02

#define PBXNOTONE					0
#define PBXDIALTONE					1
#define PBXBACKRING					2
#define PBXBUSY						3

// Only for E1 lines
#define PBXBUSYOVERLOAD				4
#define PBXPOINTTONE				5
#define PBXECHOCANCELERNEUTRICE		6
#define PBXAONREQUEST				7
#define PBXFAXREQUEST				8

#define A9MaxDigitChars				128

#pragma pack(4)
// Struct for Alder9GetVersion
typedef struct _tagDriverVersion
{	
	DWORD	dwMajor;
	DWORD	dwMinor;
	DWORD	dwLoader;
} DriverVersion;

// Data structures for Open Isa board
#define ResNoCompression			0x00
#define ResNoCompressionPlusEcho	0x01
#define ResCompression				0x02
#define ResCompressionPlusEcho		0x03
#define ResExtCompressionPlusEcho	0x04

typedef struct _tagPciBoardData
{	
	DWORD	dwBoardType;
	DWORD	dwBasePort;
	DWORD	dwCtrlPort;
	DWORD	dwIrq;
	DWORD	dwBusNumber;
} PciBoardData;

// Input data structure
typedef struct _tagBoardLoadData
{ 
	DWORD 	dwBasePort;
	BYTE	*lpbLoader;
	DWORD	dwLoadSize;
} BoardLoadData;

// Output data structure
typedef struct _tagBoardInfo
{	
	DWORD 	dwBoardHandle;
	DWORD 	dwFactoryNumber;
	DWORD	dwLoaderVersion;
	DWORD	dwE1MajorVersion;
	DWORD	dwE1MinorVersion;
	DWORD	dwResourceMode;
	DWORD	dwLines;
	DWORD	dwVoiceLines;
	BYTE	lpbLinesTypes[128];
	BYTE	lpbPossibleLinesTypes[128];
} BoardInfo;

// Data structure for Set IRQ frequency
typedef struct _tagIrqFrequencyData
{
	DWORD 	dwBoardHandle;
	DWORD 	dwIrqFrequency;
} IrqFrequencyData;


// Data structure for Get Line(s) status
typedef struct _tagLinesStatusParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwBeginLine;
	DWORD	dwAmountLines;
} LinesStatusParams;

// Data structure for Set Phone line parameters
typedef struct _tagPhoneLineParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwHookLevel;
	DWORD 	dwRingLevel;
} PhoneLineParams;

// Data structure for Set Phone line parameters
typedef struct _tagPutVoiceParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwPlayMode;
	BYTE	*lpbVoicePtr;
	DWORD 	dwLength;
} PutVoiceParams;

typedef struct _tagVolumeParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwVolume;
} VolumeParams;

typedef struct _tagRingParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} RingParams;

typedef struct _tagLockParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} LockParams;

typedef struct _tagAgcParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwDynamic;
	DWORD	dwTime;
	DWORD	dwNoiseLevel;
	DWORD	dwMode;			// AGC record mode 0 or 1 ( 0 by default)
} AgcParams;

typedef struct _tagRecordParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} RecordParams;

typedef struct _tagGetVoiceParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
} GetVoiceParams;

typedef struct _tagGainParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwGain;
} GainParams;

typedef struct _tagVoxParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	DWORD	dwLevel;
	DWORD 	dwTime;
} VoxParams;

typedef struct _tagGenerateToneParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwFrequency;
} GenerateToneParams;

typedef struct _tagPBXToneParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwPBXTone;
	DWORD	dwPBXFreqIndex;			// new!!! 0- 425 Hz 1 - 460 Hz
} PBXToneParams;

typedef struct _tagVADParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwLevel;
} VADParams;

typedef struct _tagAONParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	DWORD	dwLevel;
	DWORD	dwDelayTime;
	DWORD	dwDuration;
	DWORD 	dwRequests;
} AONParams;

typedef struct _tagEchocancelerParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwEchoMode;
	DWORD	dwRestEchoMode;
} EchocancelerParams;

typedef struct _tagLevelIndicationParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} LevelIndicationParams;

typedef struct _tagAccuParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	DWORD	dwLevel;
	DWORD	dwTime;
} AccuParams;

typedef struct _tagConnectionParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} ConnectionParams;

typedef struct _tagHookParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
} HookParams;

typedef struct _tagFlashParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwFlashTime;		// 0-15 ( mlsec= dwFlashTime*100)
} FlashParams;

// For E1 lines only!
#define NoHardwareType		0
#define VoiceHardwareType	1
#define FaxHardwareType		4

typedef struct _tagDialParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	char	pszNumber[128];
	char	pszCallerID[32];	// Caller ID, only for E1 line
	DWORD	dwHardwareType;		// 0- nothing, 1- phone, 2- fax 
} DialParams;

typedef struct _tagPlayExParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwMode;
	DWORD	dwPlayBufSize;
} PlayExParams;

typedef struct _tagSimplexSwitchParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwMode;				// 0- disconnect, != 0 connect
	DWORD 	dwSrcLine;			// Source line for output samples
	DWORD	dwDstLine;			// Destination line for input samples
	DWORD	dwVolume;			// Simplex volume
} SimplexSwitchParams;

typedef struct _tagNoiseParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwVolume;
} NoiseParams;

typedef struct _tagNoiseBlocksParams
{
	DWORD 	dwBoardHandle;
	DWORD 	dwLine;
	DWORD	dwAmount;
	DWORD	dwVolume;
} NoiseBlocksParams;

// Data structire for E1 routins
typedef struct _tagE1RawParams
{
	DWORD dwBoardHandle;
	DWORD dwMode;
} E1RawParams;

// For E1 line data structures
typedef struct _tagE1HardwareProperties
{
	DWORD dwE1DeviceAmount;
	DWORD dwE1DeviceType[2];
	DWORD dwE1LinesAmount[2];
} E1HardwareProperties;

#define drvAlderE1RawDataReady			0x00000001
#define drvAlderE1SynchroInfo 			0x00000002
#define drvAlderE1DStateInfo 			0x00000004

#define E1SynchroEstablished			0
#define E1ZeroReceive					1
#define E1AIS							2
#define E1CarrierLost					3
#define E1RemoteAlarm					4

#define E1DStateAwaitEstablish			0
#define E1DStateMultiFrame				1
#define E1DStateTimerRecovery			2
#define E1DStateError					3

typedef struct _tagE1Status
{
	DWORD	dwChanged;
	DWORD 	dwSynchroInfo[2];
	DWORD   dwDStateInfo[2];
	DWORD	dwDataReadyAmount;
} E1Status;

typedef struct _tagE1StatusParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
} E1StatusParams;

typedef struct _tagE1GetRawDataParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
} E1GetRawDataParams;

typedef struct _tagE1PutRawDataParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	WORD  *lpwRawData;
	DWORD dwLen;	
} E1PutRawDataParams;

// Data structure for E1 synchro type setup
#define E1SynchroDoubleFrame	0	// default
#define E1SynchroMultiFrame		1

typedef struct _tagE1SynchroParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwSynchroType;
} E1SynchroParams;

// Data structure for E1 linear code type setup
#define E1LinearCodeHDB3		0	// Default
#define E1LinearCodeAMI			1

typedef struct _tagE1LinearCodeParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwCodeType;
} E1LinearCodeParams;

#define E1UserUserConnection	0	// Default
#define E1NetUserConnection		1
#define E1UserNetConnection		2
#define E1NetNetConnection		3

typedef struct _tagE1ConnectionTypeParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwConnectionType;
} E1ConnectionTypeParams;

#define E1DTESlave				0
#define E1DTEMaster				1

typedef struct _tagE1DTEModeParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwDTEMode;
} E1DTEModeParams;

#define E1VoiceSynchroByBoard	0	// default
#define E1VoiceSynchroByStream	1	// synchro by E1 stream

typedef struct _tagE1VoiceSynchroParams
{
	DWORD dwBoardHandle;
	DWORD dwMode;
	DWORD dwE1Device;
	DWORD dwE1Line;
} E1VoiceSynchroParams;

#define E1LineUniversal			0	// by default
#define E1LineIncoming			1	// Only incoming seance
#define E1LineOutgoing			2	// Only outgoing seance

typedef struct _tagLineTypeParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwType;
} LineTypeParams;

#define E1TonalDetectorOff		1
#define E1TonalDetectorDTMF		3
#define E1TonalDetectorMFC1		4
#define E1TonalDetectorMFC2		5
#define E1TonalDetectorMFS		6
#define E1TonalDetectorAON		7

typedef struct _tagE1ToneDetectorParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwMode;
} E1ToneDetectorParams;

// Tone set for tone sinals (Tonal generator mode)
#define E1TonalGeneratorDTMF	0
#define E1TonalGeneratorMFC1	1
#define E1TonalGeneratorMFC2	2
#define E1TonalGeneratorMFS		3
#define E1TonalGeneratorAON		4

typedef struct _tagE1ToneGeneratorParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwMode;			// Tone set for tone sinals
	DWORD dwDuration;		// Tone signal duration
	DWORD dwPause;			// Pause duration between signals
	char  pszNum[16];		// Digits for tone generation ( 8 maximum)
} E1ToneGeneratorParams;

typedef struct _tagConferenceParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwConferenceId;	// 0-29 not more!
	DWORD dwMode;			// 0 - exclude line from conference, 
							// 1 - include line in conference
							// 2 - reset conference (exclude all lines form conf.) 
} ConferenceParams;

typedef struct _tagSimplexSwitchParamsEx
{
	DWORD 	dwDstBoardHandle; 	// Target Board for input SCbus samples
	DWORD	dwDstLine;			// Target line for input SCbus samples
	DWORD 	dwSrcBoardHandle;	// Source Board samples generator
	DWORD 	dwSrcLine;			// Src Line samples 
	DWORD 	dwMode;				// 0- disconnect, != 0 connect
	DWORD	dwVolume;			// Simplex loop volume
} SimplexSwitchParamsEx;

typedef struct _tagDTMFFilteringParams
{
	DWORD 	dwBoardHandle; 		// Target Board for input SCbus samples
	DWORD	dwLine;				// Target line for input SCbus samples
	DWORD 	dwMode;				// 0- disable, != 0 enable
} DTMFFilteringParams;

#define PolarityDisable		0
#define PolarityEnable		1
#define PolarityRequest		2

typedef struct _tagNoiseCancelerParams
{
	DWORD 	dwBoardHandle; 		// Target Board for input SCbus samples
	DWORD	dwLine;				// Target line for input SCbus samples
	DWORD 	dwNoiseLevel;		// <= 15
	DWORD	dwTimeConstant;		// Time constant for noisecanceler
} NoiseCancelerParams;

typedef struct _tagPolarityReversalParams
{
	DWORD 	dwBoardHandle; 		// Target Board for input SCbus samples
	DWORD	dwLine;				// Target line for input SCbus samples
	DWORD 	dwMode;
} PolarityReversalParams;

#define E1DialModeEnBlock		0	// By default, digit sent together in on time
#define E1DialModeOverlap		1	// Digit sent separately 

typedef struct _tagE1DialModeParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwDialMode;
} E1DialModeParams;

typedef struct _tagE1DigitsNumberParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwDigits;
} E1DigitsNumberParams;

#define E1MFREnable			0
#define E1DecadeEnable		1

typedef struct _tagE1MFRParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwEnable;			// MFR or Decade connection type on time slot
	DWORD dwToneDuration;
	DWORD dwPauseDuration;
} E1MFRParams;

typedef struct _tagE1OverlapTimeOutParams
{
	DWORD dwBoardHandle;
	DWORD dwE1Device;
	DWORD dwE1Line;
	DWORD dwTimeOut;
} E1OverlapTimeOutParams;

typedef struct _tagBoardProperties
{	
	DWORD	dwBusType;
	DWORD	dwBoardType;
	DWORD	dwBasePort;
	DWORD 	dwPciCtrlPort;
	DWORD	dwPciBus;
	BOOL	blSCBus;
	BOOL	blSCBusMaster;
	BOOL	blIrqMaster;
	DWORD	dwIrq;
	DWORD 	dwFactoryNumber;
	DWORD	dwLoaderVersion;
	DWORD	dwE1Lines;
	DWORD	dwE1MajorVersion;
	DWORD	dwE1MinorVersion;
	DWORD	dwE1STS;
	DWORD	dwResourceMode;
	DWORD	dwLines;
	DWORD	dwVoiceLines;
	BYTE	lpbLinesTypes[128];
	BYTE	lpbPossibleLinesTypes[128];
	DWORD	dwReserved[32];
} BoardProperties;

typedef struct tagLineBreakParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwDetectionMode;
	DWORD dwDetectionLevel;
} LineBreakParams;

typedef struct tagDTMFDialLevel
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwLevel;
} DTMFDialLevel;

typedef struct tagPBXToneLevel
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwLevel;
} PBXToneLevel;

typedef struct tagToneLevel
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwLevel;
} ToneLevel;

typedef struct tagDTMFSensibility
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwSensibility;
} DTMFSensibility;

typedef struct tagDTMFDetectorParams
{
	DWORD dwBoardHandle;
	DWORD dwLine;
	DWORD dwMode;
} DTMFDetectorParams;


typedef struct tagA9LineStatus
{	
	DWORD	dwChanged;
	DWORD	dwStatus;
	DWORD	dwLevel;
	DWORD	dwRecDeltaBuf;
	DWORD	dwPlayDeltaBuf;			
	DWORD	dwRawDeltaBuf;			
	DWORD	dwVoxCount;
	char    pszIncomingNum[32];    	
	char    pszIncomingQlt[16];
	char	pszUserID[32];		
	char	pszPulse[A9MaxDigitChars];
	char	pszTone[A9MaxDigitChars];
	char	chPulseNum;
	BYTE	bFill1[3];           	
	char	chToneNum;
	BYTE	bFill2[3];           	
} A9LineStatus;							
#pragma pack()

#pragma pack(2)
#if !defined(WAV_HEADER)
#define WAV_HEADER
typedef struct tagWAVEHEADER
{   BYTE 		lpbRiff[4];			// RIFF
	DWORD		dwRiffSize;			// sizeof(WAVHEADER)-8 + DataSize
	BYTE	   	lpbWave[4];			// WAVE
	BYTE	   	lpbFmt[4];			// FMT_
	DWORD		dwFmtSize;			// 20
		WORD		wFormatType;	//
		WORD		wChannels;		// ChannelsNum - always 1
		DWORD		dwFrequency;	// Always 8000
		DWORD		dwBps;        	//
		WORD 		wDataType;		//
		DWORD		dwWavMedia1;	// Unknown identifiner
		WORD		wWavMedia2;		// Unknown identifiner
		DWORD		dwSpeed;		// My compression ID
	BYTE		lpbFact[4];			// fact
	DWORD		dwFactSize;			// Always = 4;
		DWORD		dwAccount;		// Always = 0;
	BYTE		lpbData[4];			// Always= data
	DWORD		dwDataSize;       	// DataSize Count
}WAVEHEADER;
#endif
#pragma pack()

#endif
