/*
*	 -. 2000.
*	 -   
*	   OlhaFullFax.dll.
*
*         CONNECT.CPP
*/

#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "alder.h"
#include "aldererr.h"

//   .    
//     .
#define SCREENOUT	1

extern	DWORD	BoardHandle;

bool	SetHook( bool HookMode);
bool	GetLineStatus( LineStatus *ls);
bool	Dial();

//       
//      TimeOutInSec  .
bool	WaitRing( int TimeOutInSec)
{	
	LineStatus ls;
	int i;
	bool Found= false;

	for( i= 0; i< TimeOutInSec*10; i++)
	{	
		//     
		// 
		if( kbhit()!= 0)
		{	
			if( getch()== 0x1B)
			{	printf( "User break!\n");	
				break;
			}
		}
		//   
		if( GetLineStatus( &ls)== false)
			return false;
		//    ?
		if(( ls.Changed & drvAlderLineRing)!= 0)
		{	
			if(( ls.Status & drvAlderLineRing)!= 0)
			{
				#if defined( SCREENOUT)
				printf( "Ring found...\n");
				#endif
				Found= true;
				break;
			}
		}
		//    
		Sleep( 100);
	}
	if( Found== false)
		return false;
	return true;
}

//   -    .
bool CheckHooked()
{	
	LineStatus ls;			

	if( GetLineStatus( &ls)== false)
		return true;
	if(( ls.Status & drvAlderLineHook)!= 0)
		return true;
	return false;
}


//       
//   .    5 .
bool SetConnect()
{	int i;
	
	//     5 
	if( WaitRing(300)== false)
		return false;
	//  
	if( SetHook( true)== false)
		return false;
	//      3 
	//        ,
	//    ,  -  "" 
	//  .       2-3  
	for( i= 0; i< 30; i++)
	{	
		if( CheckHooked()== true)
			break;
		else
			Sleep( 100);
	}
	return true;
}


//       
//   (BUSY)
bool CheckBusy()
{	
	LineStatus ls;			

	//   
	if( GetLineStatus( &ls)== false)
		return true;
	//    BUSY?
	if(( ls.Changed & drvAlderLineBusy)!= 0)
	{	if(( ls.Status & drvAlderLineBusy)!= 0)
			return true;
	}
	return false;
}
