/*
*	 -. 2000.
*	 -   
*	   OlhaFullFax.dll.
*
*      UTILS.CPP
*/

#include <windows.h>

extern bool DialTone;

//  len    s1  s2
bool StrCmp( char *s1, char *s2, int len)
{	int i;

	if(( lstrlen( s1)< len) || ( lstrlen( s2)< len))
		return false;
	for( i= 0; i< len; i++)
	{	if( s1[i]!= s2[i])
			return false;
	}
	return true;
}

//     -  ""
DWORD BasePorts[]= {0x220, 0x224, 0x228, 0x22C, 
					0x230, 0x234, 0x238, 0x23C, 0};
bool CheckBasePorts( DWORD BasePort)
{	int i;

	for( i= 0; BasePorts[i]!= 0; i++)
	{	if( BasePort== BasePorts[i])
			return true;
	}
	return false;
}

//    IRQ  ""
DWORD Irqs[]= { 10, 11, 12, 15, 0};

bool CheckIrqs( DWORD Irq)
{	int i;

	for( i= 0; Irqs[i]!= 0; i++)
	{	if( Irq== Irqs[i])
			return true;
	}
	return false;
}

//   
char DialPulseDigits[]= "0123456789";
char DialToneDigits[]= "0123456789#*ABCDE";

bool CheckDialNumber( char *DialNum)
{	int i, j;
	bool Founded= false;

	if( lstrlen( DialNum)== 0)
		return false;
	if( DialTone== true)
	{	for( i= 0; DialNum[i]!= 0; i++)
		{	for( j= 0; DialToneDigits[j]!= 0; j++)
			{	if( DialToneDigits[j]== DialNum[i])
				{	Founded= true;
					break;
				}
			}
			if( Founded== true)
				Founded= false;
			else
				return false;
		}
	}
	else
	{	for( i= 0; DialNum[i]!= 0; i++)
		{	for( j= 0; DialPulseDigits[j]!= 0; j++)
			{	if( DialPulseDigits[j]== DialNum[i])
				{	Founded= true;
					break;
				}
			}
			if( Founded== true)
				Founded= false;
			else
				return false;
		}
	}
	return true;
}

bool FileExist( char *FileName)
{	WIN32_FIND_DATA ff;
	HANDLE FindHandle;

	FindHandle= FindFirstFile( FileName, &ff); 
	if( FindHandle!= INVALID_HANDLE_VALUE)
	{	//CloseHandle( FindHandle);
		FindClose(FindHandle);
		return true;
	}
	return false;
}