//**********************************************************************
// Agat RT, Russia, Moscow, tel.262-09-67, 747-51-12, 728-36-69
// Alder Driver Main Header File
// 01/06/2001 Version 4.70
//   21, 22, 24, 24, 616, 716
// Board loader v218 and higher
//**********************************************************************

#if !defined( ALDER_HEADER)
#define ALDER_HEADER					1

#if defined( __cplusplus)
extern "C"
#endif

// Tree VxD Driver fuctions
#define drvAlderOpenBoard				0xFAF00010
#define drvAlderCloseBoard				0xFAF00020
#define drvAlderStartBoards  			0xFAF00030
#define drvAlderStopBoards	  			0xFAF00040
#define drvAlderGetLineStatus  			0xFAF00050
#define drvAlderSetPlayer	  			0xFAF00060
#define drvAlderStartListenLine 		0xFAF00070
#define drvAlderStopListenLine  		0xFAF00080
#define drvAlderSetVolume	   			0xFAF00090
#define drvAlderSetRecordMode   		0xFAF000A0
#define drvAlderSetGainMode   			0xFAF000B0
#define drvAlderSetNumDialRecord		0xFAF000C0
#define drvAlderSetAGCRecordMode		0xFAF000D0
#define drvAlderSetAGCPlayMode			0xFAF000E0
#define drvAlderSetAonParams			0xFAF000F0
#define drvAlderSetAccuParams			0xFAF00100
#define drvAlderSetLevelMode			0xFAF00110
#define drvAlderSetHookMode				0xFAF00120
#define drvAlderDialNumber				0xFAF00130
#define drvAlderGetVoiceData			0xFAF00140
#define drvAlderPlayVoiceData			0xFAF00150
#define drvAlderSetPhoneParams			0xFAF00160
#define drvAlderSetVoxMode				0xFAF00170
#define drvAlderSetEchoMode				0xFAF00180
#define drvAlderSetIrqFreq				0xFAF00190
#define drvAlderLineGenTone				0xFAF001A0
#define drvAlderLineSetType				0xFAF001B0
#define drvAlderLineGenPBXTone			0xFAF001C0
#define drvAlderSetToneParams			0xFAF001D0
#define drvAlderLineSetRaw				0xFAF001E0
#define drvAlderSetDiscretMode			0xFAF001F0
#define drvAlderSetConnectMode			0xFAF00200
#define drvAlderSetDuplexRaw			0xFAF00210
#define drvAlderSetRawVolume			0xFAF00220
#define drvAlderLineSetRawEx			0xFAF00230
#define drvAlderGetRawData				0xFAF00240
#define drvAlderSetVadLevel				0xFAF00250
#define drvAlderLineSetPlayModeEx		0xFAF00260
#define drvAlderGetVersion				0xFAF00270
#define drvAlderGetBoardType			0xFAF00280

// This is undocumented functions for users ( developpers only)
// Kill this lines if you pass this file to any users!!!
#define drvAlderEnterInFaxMode			0xFAF00290
#define drvAlderExitFromFaxMode			0xFAF002A0
#define drvAlderGetFaxStatus			0xFAF002B0
#define drvAlderGetFaxData				0xFAF002C0

#define drvAlderSetPermissionKey		0xFAF002D0

//***
#define drvAlderOpenIsdnBoard			0xFAF002E0

// This is undocumented function for users ( developpers only)
// Kill this line if you pass this file to any users!!!
#define drvAlderPutFaxData				0xFAF002F0
//***

#define drvAlderLineSetLevelModeEx		0xFAF00300
#define drvAlderLineSetNoiseVolume		0xFAF00310

// For far Dial pulse detector
// This is undocumented function for users ( developpers only)
// Kill this line if you pass this file to any users!!!
#define drvAlderEnterInFarPulseMode	 	0xFAF00320
#define drvAlderExitFromFarPulseMode 	0xFAF00330
#define drvAlderGetFarPulseStatus	 	0xFAF00340
#define drvAlderGetFarPulseData		 	0xFAF00350
#define drvAlderSetFarPulseKey		 	0xFAF00360
#define drvAlderSetFarPulseDigit	 	0xFAF00370
#define drvAlderGetLinesStatus			0xFAF00380
#define drvAlderRingToLine				0xFAF00390
#define drvAlderLockLine				0xFAF003A0

// Undescribed! Don't pass this source for users!
#define drvAlderEnterInGateMode			0xFAF003B0
#define drvAlderExitFromGateMode		0xFAF003C0
#define drvAlderGetGateLineStatus		0xFAF003D0
#define drvAlderGetGateData				0xFAF003E0
#define drvAlderPutGateData				0xFAF003F0
#define drvAlderSetGateRecordMode		0xFAF00400
#define drvAlderSetGateKey				0xFAF00410

// Alder Board RecordMode
#define	drvNoRecord						0
#define	drvGsmRecord					1
#define	drvmLowRecord					2
#define	drvaLowRecord					3
#define	drvPcmRecord					4
#define	drvGsm610Record					5
// Only for Alder24am with 4 coprocessor module
#define	drvG729Record					6
#define	drvMpmlqRecord					7	// G723.1
#define drvAcelpRecord					8	// G723.1

// Alder Line Play Mode
#define exPlayOrdinary					0
#define exPlayUniform					1
#define exPlayUniformPauseToNoise		2

// Alder Board Type
#define Alder24aBoard					0x01
#define Alder24amBoard					0x02
#define Alder22aBoard					0x03
#define Alder21aBoard					0x20
#define Alder616Board					0x40
#define Alder716Board					0x60
#define AlderIsdnBoard					0xC0
#define AlderA10IsdnBoard				0xC5

// Alder Line LineType
#define AlderAccuLineType				0
#define AlderPhoneLineType				1

// Alder Driver Line Status
#define drvAlderLineHook            	0x00000001
#define drvAlderLineAccu            	0x00000002
#define drvAlderLineLevel           	0x00000004
#define drvAlderLineRing				0x00000008
#define drvAlderLineOutgoing			0x00000010
#define drvAlderLineIncoming			0x00000020
#define drvAlderLineNoDialTone			0x00000040
#define drvAlderLineDialTone			0x00000080
#define drvAlderLineBackRing			0x00000100
#define drvAlderLineBusy				0x00000200
#define drvAlderLineDefined				0x00000400
#define drvAlderLinePulseNum			0x00000800
#define drvAlderLineToneNum				0x00001000
#define drvAlderLineNumDialed			0x00002000
#define drvAlderLineRecord				0x00004000
#define drvAlderLinePlayed				0x00008000
#define drvAlderInNumFault				0x00010000
#define drvAlderLineInVox				0x00020000
#define drvAlderLineLastPulseNum 		0x00040000
#define drvAlderLineVAD			 		0x00080000
#define drvAlderLineToneNumDialed 		0x00100000
#define drvAlderLineFAX					0x00200000
#define drvAlderLineRawRecord			0x00400000

// Only for Alder716board
#define drvAlderLineFlash				0x00800000

// Undescribed! Don't pass this source for users!
#define drvBoardNeedNextBlock			0x40000000

#define drvAlderBoardError				0x80000000

#define PBXNOTONE						0
#define PBXDIALTONE						1
#define PBXBACKRING						2
#define PBXBUSY							3

#define MaxDigitChars					64

#pragma pack(4)
typedef struct tagLineStatus
{	DWORD		Changed;
	DWORD		Status;
	DWORD		Level;
	DWORD		RecDeltaBuf;
	DWORD		PlayDeltaBuf;		
	DWORD		RawDeltaBuf;		
	char        IncomingNum[12];    
	char        IncomingQlt[12];	
	char		Pulse[MaxDigitChars];
	char		Tone[MaxDigitChars];
	char		PulseNum;
	char		Fill1[3];
	char		ToneNum;
	BYTE		Fill2[3];
}LineStatus;						// Size:158 bytes or 39 double words
#pragma pack()

#pragma pack(2)
// WAVE Header with SCM Information
typedef struct tagSCMHEADER
{   BYTE 	MediaStart[3];
	CHAR	Alias[11];
	BYTE	Speed;		// Record Mode
	BYTE	CallType;	// Seance Type
// 16
	WORD	Year;
	BYTE	Month;
	BYTE	Day;
	BYTE	Hour;
	BYTE	Min;
	BYTE	Sec;
	BYTE	DurHour;
	BYTE	DurMin;
	BYTE	DurSec;
	DWORD	DeltaSec;
	BYTE	Phone[18];   	// Phone Number Incoming or Outgoing
// 48
	BYTE	InPhone;		// Incoming sign
	BYTE	Cat;			// Incoming Number Category
	BYTE	Tone[18];		// Tone Number
	BYTE	Free[9];		// Reserved
	BYTE	MediaEnd[3];
// 80
}SCMHEADER;

typedef struct tagWAVEHEADER
{   BYTE 		Riff[4];		// RIFF
	LONG		RiffSize;		// sizeof(WAVHEADER)-8 + DataSize
	BYTE	   	Wave[4];		// WAVE
	BYTE	   	Fmt[4];			// FMT_
	LONG		FmtSize;		// 20+sizeof(SCMHEADER)
		WORD		FormatType;	//
		WORD		Channels;	// ChannelsNum - always 1
		DWORD		Frequency;	// Always 8000
		DWORD		Bps;        //
		WORD 		DataType;	//
		DWORD		wavMedia1;	// Unknown identifiner
		WORD		wavMedia2;	// Unknown identifiner
		SCMHEADER 	scmh;		// My Data
	BYTE		Fact[4];		// fact
	LONG		FactSize;		// Always = 4;
		DWORD		Account;	// Always = 0;
	BYTE		Data[4];		// Always= data
	LONG		DataSize;       // DataSize Count
}WAVEHEADER;
#pragma pack()

#endif
