/*
*	 -. 2000.
*	 -   
*	   OlhaFullFax.dll.
*
*     CONNECT.CPP
*/

#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "alder.h"
#include "aldererr.h"
#include "utils.h"

#include "OlhaFullFax.h"

#pragma comment( lib, "OlhaFullFax.lib" )

bool	Sound= true;

// ,  16      
//   OlhaFullFax.dll
char	UserFaxKey[32];
//    -  
//    .     
//     BMP.
char	FaxFileName[256];

//      ALDER
extern	HANDLE	hcDrv;
//     
extern	DWORD	AlderBasePort, AlderIrq;
//   / 
extern	DWORD	HookLevel;
//    
extern  DWORD   RingLevel;
//  
extern	DWORD	BoardHandle;
//       (,   0)
extern	DWORD	AlderLine;
//    DialTone
extern	bool	DialTone;
//     
extern	char	DialNumber[64];

//  /    
//    .
void	SetRaw( bool OperType);
//    (.  AlderIo.cpp)
bool	OpenBoard();
//    (.  AlderIo.cpp)
void	CloseBoard();
//    (     )
bool	SetConnect();
//     (BUSY)  
bool	CheckBusy();

//    OlhaFullFax
//      !
AlderReceiveFaxData afd;

//    AlderReceiveFaxData
//      .
//      , 
// ,     !
bool OpenRcv()
{	
    ZeroMemory( &afd, sizeof( AlderReceiveFaxData));
	afd.cbSize= sizeof( AlderReceiveFaxData);
	afd.hcDrv= hcDrv;
	lstrcpy( afd.pszKey, UserFaxKey);
	afd.dwBoardHandle=BoardHandle;
	afd.dwLine= AlderLine;
	afd.EndFaxReceivFunc= NULL;
	afd.dwUserMessNumberStop=0;
	lstrcpy( afd.pszFaxFileName, FaxFileName);
	return AlderOpenFaxReceiver( &afd);
}

//    
void CloseRcv()
{	
	AlderCloseFaxReceiver(&afd);
	SetRaw( false);
}

//  /  
void SetPhone()
{	Sound=!Sound;
	SetRaw( Sound);
}

//---------------------------------------------------------------------------
char	StatConnect[80]="      ";
int		OldStatFax=0;
int		NewStatFax;
int		OldParam;

//---------------------------------------------------------------------------
void PaintStat()
{
	printf("  Status: %s  \n",StatConnect);
}

//---------------------------------------------------------------------------
int ShowStat()
{	
	NewStatFax= AlderGetReceiverStatus( &afd);

	if( OldStatFax== NewStatFax) 
		return NewStatFax;
	OldStatFax= NewStatFax;
	switch( NewStatFax)
	{	
		case  FaxReceiveSendDIS:   
		    strcpy(StatConnect," Sending DIS ");
			break;
		case  FaxReceiveWaitDCS:
			strcpy(StatConnect," Wait for DCS ");
			break;
		case  FaxReceiveTren2400:
            strcpy(StatConnect," Training 2400 ");
			break;
		case  FaxReceiveTren4800:
            strcpy(StatConnect," Training 4800 ");
			break;
		case  FaxReceiveTren7200:
            strcpy(StatConnect," Training 7200 ");
			break;
		case  FaxReceiveTren9600:
            strcpy(StatConnect," Training 9600 ");
			break;
		case  FaxReceive2400:
            strcpy(StatConnect," Receiving 2400 ");
			break;
		case  FaxReceive4800:
            strcpy(StatConnect," Receiving 4800 ");
			break;
		case  FaxReceive7200:
            strcpy(StatConnect," Receiving 7200 ");
			break;
		case  FaxReceive9600:
            strcpy(StatConnect," Receiving 9600 ");
			break;
		case  FaxReceiveWaitPMC:
            strcpy(StatConnect," Waiting for PMC ");
			break;
		case  FaxReceiveSendPIN:
            strcpy(StatConnect," Sending PIN ");
			break;
		case  FaxReceiveSendMCF:
            strcpy(StatConnect," Sending MCF ");
			break;
		case  FaxReceiveSendFTT:
            strcpy(StatConnect," Failure to training ");
			break;
		case  FaxReceiveSendCFR:
            strcpy(StatConnect," Training OK ");
			break;
		case  FaxReceiveSendCRP:
            strcpy(StatConnect," Sending CRP ");
			break;
	}
	PaintStat();
	return NewStatFax;
}

void ShowFinalStatus()
{
	switch( afd.dwFinalStatus)
	{
		case FaxReceiveNoError:		
			printf("OK!\n");
			break;
		 case FaxReceiveSystemError:
			printf("There was a system error during receiving. GetLastError:%d\n",
					afd.dwSystemError);
			break;
		case FaxReceiveDriverError:			
			printf(" N:%d. The driver has returned a error number %04X\n",
					afd.dwUserMessNumberStop, afd.dwDrvError);
			break;
		case FaxReceiveDeviceIoError:		
			printf(" DeviceIOControl was finished unsuccessfully. GetLastError:%d\n", 
					afd.dwSystemError);
			break;
		case FaxReceiveMemoryFault:			
			printf(" Error at allocation of memory.\n");
			break;
		case FaxReceiveAlreadyStarted:		
			printf(" The receiver is already started.\n");
			break;
		case FaxReceiveFileWriteError:
			printf(" Error at record of a out file\n");
			break;
		case FaxReceiveNoFaxPages:			
			printf(" In an input file there are no facsimile sheets.\n");
			break;
		case FaxReceiveTooManyLines:
			printf(" Too large number of a board / channel\n");
			break;
		case FaxReceiveDriverVersionFault:	
			printf(" The wrong version of the driver.\n");
			break;
		case FaxReceiveFileCorrupt:
			printf(" The input file is corrupted.\n");
			break;
		case FaxReceiveMustBeRun:
			printf(" The receiver should be already started.\n");
			break;
		case FaxReceiveUncorrectVersion:
			printf( "Uncorrect Dll version!\n");
			break;
		default:
			printf("Ungecognized error.\n");
			break;
	}
}


//      
//      
bool GetKeys( int argc, char **argv)
{	
	int i;

	for( i= 1; i< argc; i++)
	{	strupr( argv[i]);
		//      
		if( StrCmp( argv[i], "/K:", 3)== true)
		{	
			lstrcpy( UserFaxKey, argv[i]+ 3);
			continue;
		}
		//   -  ""
		if( StrCmp( argv[i], "/P:", 3)== true)
		{	
			sscanf( argv[i]+ 3, "%X", &AlderBasePort);
			if( CheckBasePorts( AlderBasePort)== false)
			{	
				printf( "%s. Base port fault!\n", argv[i]);
				return false;
			}
			continue;
		}
		//    ""
		if( StrCmp( argv[i], "/I:", 3)== true)
		{	
			sscanf( argv[i]+ 3, "%d", &AlderIrq);
			if( CheckIrqs( AlderIrq)== false)
			{	
				printf( "%s. IRQ fault!\n", argv[i]);
				return false;
			}
			continue;
		}
		//  /   
		//    ,     
		// -!      8 (28)
		//  - -  4 (18).
		//         
		//         .
		if( StrCmp( argv[i], "/H:", 3)== true)
		{	sscanf( argv[i]+ 3, "%d", &HookLevel);
			if(( HookLevel< 0) || ( HookLevel> 15))
			{	printf( "%s. HookLevel fault!\n", argv[i]);
				return false;
			}
			continue;
		}

		//    .  1 (70)   !
		if( StrCmp( argv[i], "/R:", 3)== true)
		{	sscanf( argv[i]+ 3, "%d", &RingLevel);
			if(( RingLevel< 0) || ( RingLevel> 3))
			{	printf( "%s. RingLevel fault!\n", argv[i]);
				return false;
			}
			continue;
		}

		//        
		if( StrCmp( argv[i], "/L:", 3)== true)
		{	sscanf( argv[i]+ 3, "%d", &AlderLine);
			if(( AlderLine< 0) || ( AlderLine> 3))
			{	printf( "%s. Line number fault!\n", argv[i]);
				return false;
			}
			continue;
		}
		//  BMP     
		if(( argv[i][0]!= '/') && ( FaxFileName[0]== 0))
		{	
			lstrcpy( FaxFileName, argv[i]);
			continue;
		}
	}
	return true;
}

//       .
void PrintUsage( char *ProgName)
{	
	char *Ptr;

	Ptr= strrchr( ProgName, '\\');
	if( Ptr== 0)
		Ptr= ProgName;
	else
		Ptr++;
	printf( "\n\nFax receiver for Alder board. AgatRT. 2000 \n");
	printf( "Usage:\n  %s [/P:n] [/I:n]  [/R:n] [/L:n] <BMPImageFile>\n", Ptr);
	printf( " Keys:\n");
	printf( "  /K:<string>  - Alder user key for using OlhaFullFax\n");
	printf( "  /P:n   n - Alder board base port (23C - default)\n");
	printf( "  /I:n   n - Alder board IRQ (11 - default)\n");
	printf( "  /H:n   Hook level 0-15 (4 - default)\n");
	printf( "  /R:n   Ring level 0-3 (3 - default)\n");
	printf( "  /L:n   n - Alder board line for fax receiving (0 - default)\n");
	printf( "  <BMPImageFile> - Out file (required!)\n\n");
}

//  
void main( int argc, char **argv)
{	
	DWORD MajorVersion, MinorVersion;

	if( argc== 1)
	{	PrintUsage( argv[0]);
		return;
	}
	if( GetKeys( argc, argv)== false)
	{	PrintUsage( argv[0]);
		return;
	} 

	//        
	printf( "AlderBasePort:     %04X\n", AlderBasePort);
	printf( "AlderIrq:          %d\n", AlderIrq);
	printf( "AlderLine:         %d\n", AlderLine);
	printf( "HookLevel:         %d\n", HookLevel);
	printf( "RingLevel:         %d\n", RingLevel);
	printf( "FaxImageFile:      %s\n", FaxFileName);

	AlderGetDllVersion( &MajorVersion, &MinorVersion);
	printf( "\nOlhaFullFaxVersion: %d.%d\n", MajorVersion, MinorVersion);

	//   ""
	if( OpenBoard()== false) 
	{	
		PrintUsage( argv[0]);
		return;
	} 

	//      
	//     
	SetRaw( Sound);

	//  .    ,
	//       .
	if( SetConnect()== false)
	{	
		printf( "Error! Unable set connect!\n");
	    CloseBoard();
		return;
	}
	
	//   
	OpenRcv();

	printf("\n\n  Receiving file \'%s\' from line %d\n", 
			FaxFileName, AlderLine);
	printf("\n\n  'Q' - quit,  'S' - sound on/off \n\n\n\n\n");
	do
	{	
		//    (BUSY)  .
		if( CheckBusy()== true)
			break;
		printf("\r");
		if( kbhit()!=0) 
		{	
			switch( getch())
			{	
				case 's':
				case 'S':
					// /     ""
					SetPhone();
					break;
				case 0x1b:
				case 'q':
				case 'Q':
					//    
					break;
			}
		}
		Sleep(50);
	} while( ShowStat()!= FaxReceiveOff);
	CloseRcv();

	ShowFinalStatus();
	CloseBoard();
}

