/*
*	 -. 2000.
*	 -   
*	   OlhaFullFax.dll.
*
*         CONNECT.CPP
*/
#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "alder.h"
#include "aldererr.h"

//   .    
//     .
#define SCREENOUT	1

extern	DWORD	BoardHandle;
extern	bool	DialTone;
extern	char	DialNumber[64];

bool	SetHook( bool HookMode);
bool	GetLineStatus( LineStatus *ls);
bool	Dial();

//     (DIALTONE)
//      TimeOutInSec
bool	WaitDialTone( int TimeOutInSec)
{	LineStatus ls;
	int i;
	bool Found= false;

	for( i= 0; i< TimeOutInSec*10; i++)
	{	
		if( kbhit()!= 0)
		{	if( getch()== 0x1B)
			{	printf( "User break!\n");	
				break;
			}
		}

		if( GetLineStatus( &ls)== false)
			return false;
		if(( ls.Changed & drvAlderLineDialTone)!= 0)
		{	if(( ls.Status & drvAlderLineDialTone)!= 0)
			{
				#if defined( SCREENOUT)
				printf( "DialTone found...\n");
				#endif
				Found= true;
				break;
			}
		}
		Sleep( 100);
	}
	if( Found== false)
		return false;
	return true;
}

//      
bool	WaitNumDialed( int TimeOutInSec)
{	LineStatus ls;
	int i;
	bool Found= false;

	for( i= 0; i< TimeOutInSec*10; i++)
	{	//   ?
		if( kbhit()!= 0)
		{	if( getch()== 0x1B)
			{	printf( "User break!\n");
				break;
			}
		}

		if( GetLineStatus( &ls)== false)
			return false;
		if( DialTone== false)
		{	if(( ls.Changed & drvAlderLineNumDialed)!= 0)
			{	if(( ls.Status & drvAlderLineNumDialed)!= 0)
				{	
					#if defined( SCREENOUT)
					printf( "Phone Number in pulse mode dialed...\n");
					#endif
					Found= true;
					break;
				}
			}
		}
		else
		{	if(( ls.Changed & drvAlderLineToneNumDialed)!= 0)
			{	if(( ls.Status & drvAlderLineToneNumDialed)!= 0)
				{	
					#if defined( SCREENOUT)
					printf( "Phone Number in tone mode dialed...\n");
					#endif
					Found= true;
					break;
				}
			}
		}
		Sleep( 100);
	}
	if( Found== false)
		return false;
	return true;
}

//   -   
// "", .
bool WaitFaxCarrier( int TimeOutInSec)
{	
	LineStatus ls;
	int i;
	bool Found= false;

	for( i= 0; i< TimeOutInSec*10; i++)
	{	//   ?
		if( kbhit()!= 0)
		{	if( getch()== 0x1B)
			{	printf( "User break!\n");
				break;
			}
		}

		if( GetLineStatus( &ls)== false)
			return false;
		//  -
		if(( ls.Changed & drvAlderLineFAX)!= 0)
		{	if(( ls.Status & drvAlderLineFAX)!= 0)
			{
//				#if defined( SCREENOUT)
				printf( "FAX carrier detected...\n");
//				#endif
				Found= true;
				break;
			}
		}
		//   
		if(( ls.Changed & drvAlderLineVAD)!= 0)
		{	if(( ls.Status & drvAlderLineVAD)!= 0)
			{
//				#if defined( SCREENOUT)
				printf( "VAD carrier detected...\n");
//				#endif
				Found= true;
				break;
			}
		}
		Sleep( 100);
	}
	if( Found== false)
		return false;
	return true;
}



//      
bool SetConnect()
{	
	//  
	if( SetHook( true)== false)
		return false;
	//    (DIALTONE)
	if( WaitDialTone(10)== false)
		return false;
	//  
	if( Dial()== false)
		return false;
	//    
	if( WaitNumDialed( 20)== false)
		return false;
/*
	//  -   
	if( WaitFaxCarrier( 30)== false)
		return false;
*/
	return true;
}

/*
bool	SetHook( bool HookMode);
bool	GetLineStatus( LineStatus *ls);
bool	Dial();

bool	WaitRing( int TimeOutInSec)
{	LineStatus ls;
	int i;
	bool Found= false;

	for( i= 0; i< TimeOutInSec*10; i++)
	{	
		if( kbhit()!= 0)
		{	if( getch()== 0x1B)
			{	printf( "User break!\n");	
				break;
			}
		}
		if( GetLineStatus( &ls)== false)
			return false;
		if(( ls.Changed & drvAlderLineRing)!= 0)
		{	
			if(( ls.Status & drvAlderLineRing)!= 0)
			{
//				#if defined( SCREENOUT)
				printf( "Ring found...\n");
//				#endif
				Found= true;
				break;
			}
		}
		Sleep( 100);
	}
	if( Found== false)
		return false;
	return true;
}
*/

bool CheckHooked()
{	LineStatus ls;			

	if( GetLineStatus( &ls)== false)
		return true;
	if(( ls.Status & drvAlderLineHook)!= 0)
		return true;
	return false;
}

/*
bool SetConnect()
{	int i;
	
	if( WaitRing(300)== false)
		return false;
	if( SetHook( true)== false)
		return false;
	for( i= 0; i< 30; i++)
	{	
		if( CheckHooked()== true)
			break;
		else
			Sleep( 100);
	}
	return true;
}
*/

//    (BUSY)
bool CheckBusy()
{	LineStatus ls;			

	if( GetLineStatus( &ls)== false)
		return true;
	if(( ls.Changed & drvAlderLineBusy)!= 0)
	{	if(( ls.Status & drvAlderLineBusy)!= 0)
			return true;
	}
	return false;
}

