#ifndef _ALDER_FULLFAX_HEADER
#define _ALDER_FULLFAX_HEADER


#define OLHA_FULL_FAX_VERSION	30

#define DllImport	extern "C" __declspec( dllimport )

#define MaxLenFileName 256

#pragma pack(4)
typedef struct tagAlderTransmitFaxData
{	
	DWORD			cbSize;
	HANDLE			hcDrv;
	DWORD			dwBoardHandle;
	DWORD			dwLine;
	char			pszKey[32];
	char			pszFaxFileName[MaxLenFileName];
//	DWORD			dwFileAttributes;
	void			(_stdcall* EndFaxTransmitFunc)(void *);

	HWND			hWinHandleStop;
	DWORD			dwUserMessNumberStop;

	DWORD			dwFinalStatus;                 
	DWORD			dwSystemError;
	DWORD			dwProcessStatus;
	DWORD			dwDrvError;

	BYTE			bPrivate[192];
} AlderTransmitFaxData;
#pragma pack()


//     (.  FinalStatus)
//  AlderTransmitFaxData
#define FaxTransmitNoError				0x0000
#define FaxTransmitSystemError			0xFF01
#define FaxTransmitDriverError			0xFF02
#define FaxTransmitDeviceIoError		0xFF03
#define FaxTransmitMemoryFault			0xFF04
#define FaxTransmitAlreadyStarted		0xFF05
#define FaxTransmitFileReadError		0xFF08
#define FaxTransmitNoFaxPages			0xFF09
#define FaxTransmitTooManyLines			0xFF0A
#define FaxTransmitVersionFault			0xFF0B
#define FaxTransmitDriverVersionFault	0xFF0C
#define FaxTransmitFileCorrupt          0xFF0D
#define FaxTransmitMustBeRun			0xFF0E
#define FaxTransmitUncorrectVersion		0xFF0F

//     (.  ProcessStatus)
//  AlderTransmitFaxData
#define FaxTransmitOff					0
#define FaxTransmitConnecting			1
#define FaxTransmitTraining				2
#define FaxTransmitSending				3

//    BMP   
//  OlhaFullFax
//  BMP      
//   1728 .   
//    !!!
//     2210 
//     2210    
//  2210 .
DllImport int  bmp2fax( char *DestFile, char *SrcFile);

//     
DllImport bool	AlderOpenFaxTransmission( AlderTransmitFaxData *); 
//    
DllImport bool	AlderCloseFaxTransmission( AlderTransmitFaxData *);
//     
DllImport int	AlderGetTransmissionStatus( AlderTransmitFaxData *, int *param);

typedef struct tagAlderReceiveFaxData
{	
	DWORD		cbSize;
	HANDLE		hcDrv;
	DWORD		dwBoardHandle;
	DWORD		dwLine;
	char		pszKey[32];
	char		pszFaxFileName[MaxLenFileName];
//	DWORD		dwFileAttributes;
	void		(_stdcall* EndFaxReceivFunc)(void *);

	HWND		hWinHandleStop;
	DWORD		dwUserMessNumberStop;

	DWORD		dwFinalStatus;                 
	DWORD		dwSystemError;
	DWORD		dwProcessStatus;
	DWORD		dwDrvError;
	BYTE		bPrivate[960];
} AlderReceiveFaxData;

#pragma pack()

//     (.  FinalStatus)
//  AlderReceiveFaxData
#define FaxReceiveNoError				0x0000
#define FaxReceiveSystemError			0xFF01
#define FaxReceiveDriverError			0xFF02
#define FaxReceiveDeviceIoError			0xFF03
#define FaxReceiveMemoryFault			0xFF04
#define FaxReceiveAlreadyStarted		0xFF05
#define FaxReceiveFileWriteError		0xFF08
#define FaxReceiveNoFaxPages			0xFF09
#define FaxReceiveTooManyLines			0xFF0A
#define FaxReceiveVersionFault			0xFF0B
#define FaxReceiveDriverVersionFault	0xFF0C
#define FaxReceiveFileCorrupt			0xFF0D
#define FaxReceiveMustBeRun				0xFF0E
#define FaxReceiveUncorrectVersion		0xFF0F

//     (.  ProcessStatus)
//  AlderReceiveFaxData
#define FaxReceiveOff			0
#define FaxReceiveSendDIS		1
#define FaxReceiveWaitDCS		2
#define FaxReceiveTren2400		3
#define FaxReceiveTren4800		4
#define FaxReceiveTren7200		5
#define FaxReceiveTren9600		6
#define FaxReceive2400				7
#define FaxReceive4800				8
#define FaxReceive7200				9
#define FaxReceive9600				10
#define FaxReceiveWaitPMC			11
#define FaxReceiveSendPIN			12
#define FaxReceiveSendMCF			13
#define FaxReceiveSendFTT			14
#define FaxReceiveSendCFR			15
#define FaxReceiveSendCRP			16
#define FaxReceiveDevErrFax			98
#define FaxReceiveSysErrFax			99

//    
DllImport void AlderGetDllVersion( DWORD *MajorVersion, DWORD *MinorVersion);
//    
DllImport bool AlderOpenFaxReceiver( AlderReceiveFaxData *);
//    
DllImport bool AlderCloseFaxReceiver( AlderReceiveFaxData *);
//     
DllImport int  AlderGetReceiverStatus( AlderReceiveFaxData *);

//     -  bmp
DllImport int  AlderFaxBmpConvert(char *faxfilename,char *bmpfilename);


#endif
